# coding: utf-8

"""
    Selling Partner API for Reports

    The Selling Partner API for Reports lets you retrieve and manage a variety of reports that can help selling partners manage their businesses.  # noqa: E501

    OpenAPI spec version: 2020-09-04
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class CreateReportScheduleSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'report_type': 'str',
        'report_options': 'ReportOptions',
        'period': 'str',
        'next_report_creation_time': 'datetime'
    }

    attribute_map = {
        'report_type': 'reportType',
        'report_options': 'reportOptions',
        'period': 'period',
        'next_report_creation_time': 'nextReportCreationTime'
    }

    def __init__(self, report_type=None, report_options=None, period=None, next_report_creation_time=None, **kwargs):  # noqa: E501
        """CreateReportScheduleSpecification - a model defined in Swagger"""  # noqa: E501
        self._report_type = None
        self._report_options = None
        self._period = None
        self._next_report_creation_time = None
        self.discriminator = None
        self.report_type = report_type

        if report_options is not None:
            self.report_options = report_options
        self.period = period
        if next_report_creation_time is not None:
            self.next_report_creation_time = next_report_creation_time

    @property
    def report_type(self):
        """Gets the report_type of this CreateReportScheduleSpecification.  # noqa: E501

        The report type.  # noqa: E501

        :return: The report_type of this CreateReportScheduleSpecification.  # noqa: E501
        :rtype: str
        """
        return self._report_type

    @report_type.setter
    def report_type(self, report_type):
        """Sets the report_type of this CreateReportScheduleSpecification.

        The report type.  # noqa: E501

        :param report_type: The report_type of this CreateReportScheduleSpecification.  # noqa: E501
        :type: str
        """
        if report_type is None:
            raise ValueError("Invalid value for `report_type`, must not be `None`")  # noqa: E501

        self._report_type = report_type

    @property
    def report_options(self):
        """Gets the report_options of this CreateReportScheduleSpecification.  # noqa: E501


        :return: The report_options of this CreateReportScheduleSpecification.  # noqa: E501
        :rtype: ReportOptions
        """
        return self._report_options

    @report_options.setter
    def report_options(self, report_options):
        """Sets the report_options of this CreateReportScheduleSpecification.


        :param report_options: The report_options of this CreateReportScheduleSpecification.  # noqa: E501
        :type: ReportOptions
        """

        self._report_options = report_options

    @property
    def period(self):
        """Gets the period of this CreateReportScheduleSpecification.  # noqa: E501

        One of a set of predefined ISO 8601 periods that specifies how often a report should be created.  # noqa: E501

        :return: The period of this CreateReportScheduleSpecification.  # noqa: E501
        :rtype: str
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this CreateReportScheduleSpecification.

        One of a set of predefined ISO 8601 periods that specifies how often a report should be created.  # noqa: E501

        :param period: The period of this CreateReportScheduleSpecification.  # noqa: E501
        :type: str
        """
        if period is None:
            raise ValueError("Invalid value for `period`, must not be `None`")  # noqa: E501
        allowed_values = ["PT5M", "PT15M", "PT30M", "PT1H", "PT2H", "PT4H", "PT8H", "PT12H", "P1D", "P2D", "P3D", "PT84H", "P7D", "P14D", "P15D", "P18D", "P30D", "P1M"]  # noqa: E501
        period = period.value
        if period not in allowed_values:
            raise ValueError(
                "Invalid value for `period` ({0}), must be one of {1}"  # noqa: E501
                .format(period, allowed_values)
            )

        self._period = period

    @property
    def next_report_creation_time(self):
        """Gets the next_report_creation_time of this CreateReportScheduleSpecification.  # noqa: E501

        The date and time when the schedule will create its next report, in ISO 8601 date time format.  # noqa: E501

        :return: The next_report_creation_time of this CreateReportScheduleSpecification.  # noqa: E501
        :rtype: datetime
        """
        return self._next_report_creation_time

    @next_report_creation_time.setter
    def next_report_creation_time(self, next_report_creation_time):
        """Sets the next_report_creation_time of this CreateReportScheduleSpecification.

        The date and time when the schedule will create its next report, in ISO 8601 date time format.  # noqa: E501

        :param next_report_creation_time: The next_report_creation_time of this CreateReportScheduleSpecification.  # noqa: E501
        :type: datetime
        """

        self._next_report_creation_time = next_report_creation_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateReportScheduleSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateReportScheduleSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
